import Tkinter as tk # GUI
import tkFont as tkFont # Fonts for GUI
from functools import partial
import pygame

class GUI(tk.Tk):
	"""The application class inherits the tk.Tk highest level window object
	"""

	def btnpress(self,letter):
		pygame.mixer.music.load("./audio/PremiumBeat_0046_sci_fi_beep_electric.mp3")
		pygame.mixer.music.play()
		if (self.current_digit==0):
			self.answerlabel[0].configure(text=" ")
			self.answerlabel[1].configure(text=" ")
			self.answerlabel[2].configure(text=" ")
			
		if (self.current_digit<3):
			self.answerlabel[self.current_digit].configure(text=letter)
			self.answer[self.current_digit] = self.answerkey[letter]
			self.current_digit +=1

	def btnenter(self):
		self.current_digit = 0
		if (self.answerlabel[0].cget("text")== "N" and self.answerlabel[1].cget("text")== "O" and self.answerlabel[2].cget("text")== "G"):
			self.success()
		else:
			self.answerlabel[0].configure(text=self.answer[0])
			self.answerlabel[1].configure(text=self.answer[1])
			self.answerlabel[2].configure(text=self.answer[2])
			self.answer[0] = 0
			self.answer[1] = 0
			self.answer[2] = 0
			pygame.mixer.music.load("./audio/PremiumBeat_0046_sci_fi_beep_electric_4.mp3")
			pygame.mixer.music.play()

	def success(self):
		self.win_state = True
		background_image2=tk.PhotoImage(file="./images/granted_full.gif")
		background_label2 = tk.Label(self, image=background_image2, borderwidth=0, relief="flat")
		background_label2.photo = background_image2
		background_label2.place(x=0, y=0)
		pygame.mixer.music.load("./audio/PremiumBeat_0046_sci_fi_type_beep.mp3")
		pygame.mixer.music.play()
		self.after(300000, self.quit)

	def __init__(self):
		"""Create all the GUI elements
		"""
		tk.Tk.__init__(self) # call __init__ method belonging to the parent class
		self.title("Krampus Access") # give a title to main window
		self.protocol("WM_DELETE_WINDOW", self.exitall) # quit if the window is deleted
		#self.state("normal") # Set it to maximized state
		pygame.init()		
		pygame.mixer.init()
		self.answer = {}
		self.win_state = False
		self.answerkey = { "A":14, "B":10, "C":22, "D":21, "E":19, "F":11, "G":20, "H":4, "I":24, "J":3, "K":21, "L":26, "M":5, "N":7, "O":13, "P":8, "Q":17, "R":16, "S":2, "T":15, "U":1, "V":9, "W":18, "X":25, "Y":23, "Z":6}
		self.attributes('-fullscreen', True)
		villain = tkFont.Font(family="Old Time Villain", size=50)
		self.current_digit = 0
		background_image=tk.PhotoImage(file="./images/background.gif")
		background_label = tk.Label(self, image=background_image, borderwidth=0, relief="flat")
		background_label.photo = background_image
		background_label.place(x=0, y=0)
		
		toprow = "QWERTYUIOP"
		middlerow = "ASDFGHJKL"
		bottomrow = "ZXCVBNM"
		self.answerrowframe = tk.Frame(self, bg="black")
		self.answerrowframe.place(x=200, y=125)
		self.answerlabel = {}
		buttonwidth = 90
		buttonheight = 100

		self.passwordlabel = tk.Label(self.answerrowframe,text="PASSWORD: ",font=villain, bg="black", fg="green")
		self.passwordlabel.pack(side=tk.LEFT, padx = 5)
		for i in (range(0,4)):
			self.answerlabel[i] = tk.Label(self.answerrowframe,text=" ",font=villain, bg="black", fg="green")
			self.answerlabel[i].config(width=2)
			self.answerlabel[i].pack(side=tk.LEFT, padx = 25)

		self.toprowframe = tk.Frame(self, bg="black")
		self.toprowframe.place(x=150,y=275)
		self.btn = {}
		for i in (list(toprow)):
			self.btn[i] = tk.Button(self.toprowframe,text=i,font=villain, bg="black", fg="green", activebackground='green', command=partial(self.btnpress,i))
			self.btn[i].img = tk.PhotoImage()
			self.btn[i].config(width=buttonwidth, height=buttonheight, image=self.btn[i].img, compound=tk.CENTER)
			self.btn[i].pack(side=tk.LEFT, padx = 2)
		self.middlerowframe = tk.Frame(self, bg="black")
		self.middlerowframe.place(x=175,y=400)
		for i in (list(middlerow)):
			self.btn[i] = tk.Button(self.middlerowframe,text=i,font=villain, bg="black", fg="green", activebackground='green', command=partial(self.btnpress,i))
			self.btn[i].img = tk.PhotoImage()
			self.btn[i].config(width=buttonwidth, height=buttonheight, image=self.btn[i].img, compound=tk.CENTER)
			self.btn[i].pack(side=tk.LEFT, padx = 2)
		self.bottomrowframe = tk.Frame(self, bg="black")
		self.bottomrowframe.place(x=160,y=525)
		for i in (list(bottomrow)):
			self.btn[i] = tk.Button(self.bottomrowframe,text=i,font=villain, bg="black", fg="green", activebackground='green', command=partial(self.btnpress,i))
			self.btn[i].img = tk.PhotoImage()
			self.btn[i].config(width=buttonwidth, height=buttonheight, image=self.btn[i].img, compound=tk.CENTER)
			self.btn[i].pack(side=tk.LEFT, padx = 2)

		self.enter = tk.Button(self.bottomrowframe,text="enter", font=villain, bg="black", fg="green", activebackground='green', command=self.btnenter)
		self.enter.img = tk.PhotoImage()
		self.enter.config(width=200, height=buttonheight, image=self.enter.img, compound=tk.CENTER)
		self.enter.pack(side=tk.LEFT, padx = 30)

	def quit(self, event=None):
		self.exitall()

	def exitall(self):
		self.destroy()
